;;; CHICKEN Transducers - Transducers for working with foldable data types.
;;;
;;; Copyright (c) 2023 Jeremy Steward
;;;
;;; Permission is hereby granted, free of charge, to any person obtaining a copy
;;; of this software and associated documentation files (the "Software"), to deal
;;; in the Software without restriction, including without limitation the rights
;;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;;; copies of the Software, and to permit persons to whom the Software is
;;; furnished to do so, subject to the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included in all
;;; copies or substantial portions of the Software.
;;;
;;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;;; SOFTWARE.

;; Reduced values record members
(export <reduced>
        make-reduced
        reduced?
        unwrap
        preserving-reduced)

;; Collectors
(export collect-any
        collect-all
        collect-count
        collect-max
        collect-min
        collect-first
        collect-last
        collect-sum
        collect-product
        collect-void)

;; Transduce procedures
(export transduce for-each)

;; Transducers
(export map
        filter
        remove
        drop
        drop-while
        take
        take-while
        chunks
        chunks-exact
        enumerate
        inspect)

;; Syntax
(export define-chain-transducer
        define-flatten-transducer
        define-interleave-transducer
        define-zip-transducer)

;; Transducible type-classes
(export <transducible>
        make-transducible
        transducible?
        transducible-folder
        transducible-collector
        transducible-flattener
        transducible-chainer
        transducible-interleaver
        transducible-zipper)
